function varargout = changeAdvancedModelSettings_GUI(varargin)
%
%     Copyright 2017 Matthias Stangl, Jonathan Shine, Thomas Wolbers
%     matthias.stangl@dzne.de, jonathan.shine@dzne.de, thomas.wolbers@dzne.de
% 
%     This file is part of the GridCAT.
% 
%     The GridCAT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     The GridCAT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with the GridCAT.  If not, see <http://www.gnu.org/licenses/>.
%
%
% CHANGEADVANCEDMODELSETTINGS_GUI MATLAB code for changeAdvancedModelSettings_GUI.fig
%      CHANGEADVANCEDMODELSETTINGS_GUI, by itself, creates a new CHANGEADVANCEDMODELSETTINGS_GUI or raises the existing
%      singleton*.
%
%      H = CHANGEADVANCEDMODELSETTINGS_GUI returns the handle to a new CHANGEADVANCEDMODELSETTINGS_GUI or the handle to
%      the existing singleton*.
%
%      CHANGEADVANCEDMODELSETTINGS_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CHANGEADVANCEDMODELSETTINGS_GUI.M with the given input arguments.
%
%      CHANGEADVANCEDMODELSETTINGS_GUI('Property','Value',...) creates a new CHANGEADVANCEDMODELSETTINGS_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before changeAdvancedModelSettings_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to changeAdvancedModelSettings_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help changeAdvancedModelSettings_GUI

% Last Modified by GUIDE v2.5 27-Oct-2016 09:19:55

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @changeAdvancedModelSettings_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @changeAdvancedModelSettings_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before changeAdvancedModelSettings_GUI is made visible.
function changeAdvancedModelSettings_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to changeAdvancedModelSettings_GUI (see VARARGIN)

% Choose default command line output for changeAdvancedModelSettings_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% ------------------------------------------------
% mst-edit:

% adapt position of the new GUI
adaptFigurePosition(hObject);

% Change font size of all GUI elements depending on current platform, if necessary 
ud = getUserData(hObject, 'UserData');
if ~isfield(ud, 'fontSizeAdapted') || ~ud.fontSizeAdapted
    changeFontSizesIfReq(handles, hObject);
end

% Make the GUI modal
set(handles.figure1,'WindowStyle', 'modal');

% change figure name
set(handles.figure1, 'Name', 'GridCAT - Model Settings');

% display current settings in GUI elements
currentSettings = varargin{1};
set(handles.edit_microtimeOnset, 'String', num2str(currentSettings.microtimeOnset));
set(handles.edit_microtimeResolution, 'String', num2str(currentSettings.microtimeResolution));
set(handles.edit_HPF, 'String', currentSettings.HPF_str);
set(handles.edit_maskingThreshold, 'String', num2str(currentSettings.maskingThreshold));
switch sum(currentSettings.derivatives)
    case 0
        set(handles.popupmenu_derivatives, 'Value', 1);
    case 1
        set(handles.popupmenu_derivatives, 'Value', 2);
    case 2
        set(handles.popupmenu_derivatives, 'Value', 3);
end

drawnow

% ------------------------------------------------

% UIWAIT makes defineContrastVector_GUI_alt wait for user response (see UIRESUME)
uiwait(handles.figure1); % mst-edit


% --- Outputs from this function are returned to the command line.
function varargout = changeAdvancedModelSettings_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% ------------------------------------------------
% mst-edit:

newSettings = [];
ud = getUserData(handles.figure1, 'UserData');
if isfield(ud, 'userPressedOK') && ud.userPressedOK
    newSettings.HPF_str = get(handles.edit_HPF, 'String');
    newSettings.maskingThreshold = str2double(get(handles.edit_maskingThreshold, 'String'));
    newSettings.microtimeResolution = str2double(get(handles.edit_microtimeResolution, 'String'));
    newSettings.microtimeOnset = str2double(get(handles.edit_microtimeOnset, 'String'));
    switch get(handles.popupmenu_derivatives, 'Value')
        case 1
            newSettings.derivatives = [0 0];
        case 2
            newSettings.derivatives = [1 0];
        case 3
            newSettings.derivatives = [1 1];
    end
end
varargout{1} = newSettings;


delete(handles.figure1);
% ------------------------------------------------


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
% delete(hObject); % mst-edit

% mst-edit:
if isequal(get(hObject, 'waitstatus'), 'waiting')
    uiresume(hObject);
else
    delete(hObject);
end


% --- Executes on button press in pushbutton_OK.
function pushbutton_OK_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_OK (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ud = getUserData(handles.figure1, 'UserData');
ud.userPressedOK = 1;
set(handles.figure1, 'UserData', ud);

close(handles.figure1);


% --- Executes on button press in pushbutton_Cancel.
function pushbutton_Cancel_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ud = getUserData(handles.figure1, 'UserData');
ud.userPressedOK = 0;
set(handles.figure1, 'UserData', ud);

close(handles.figure1);


function edit_microtimeOnset_Callback(hObject, eventdata, handles)
% hObject    handle to edit_microtimeOnset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_microtimeOnset as text
%        str2double(get(hObject,'String')) returns contents of edit_microtimeOnset as a double


% --- Executes during object creation, after setting all properties.
function edit_microtimeOnset_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_microtimeOnset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_microtimeResolution_Callback(hObject, eventdata, handles)
% hObject    handle to edit_microtimeResolution (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_microtimeResolution as text
%        str2double(get(hObject,'String')) returns contents of edit_microtimeResolution as a double


% --- Executes during object creation, after setting all properties.
function edit_microtimeResolution_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_microtimeResolution (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_maskingThreshold_Callback(hObject, eventdata, handles)
% hObject    handle to edit_maskingThreshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_maskingThreshold as text
%        str2double(get(hObject,'String')) returns contents of edit_maskingThreshold as a double


% --- Executes during object creation, after setting all properties.
function edit_maskingThreshold_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_maskingThreshold (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_HPF_Callback(hObject, eventdata, handles)
% hObject    handle to edit_HPF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_HPF as text
%        str2double(get(hObject,'String')) returns contents of edit_HPF as a double


% --- Executes during object creation, after setting all properties.
function edit_HPF_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_HPF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_derivatives.
function popupmenu_derivatives_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_derivatives (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_derivatives contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_derivatives


% --- Executes during object creation, after setting all properties.
function popupmenu_derivatives_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_derivatives (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
