function varargout = defineContrastVector_GUI(varargin)
%
%     Copyright 2017 Matthias Stangl, Jonathan Shine, Thomas Wolbers
%     matthias.stangl@dzne.de, jonathan.shine@dzne.de, thomas.wolbers@dzne.de
% 
%     This file is part of the GridCAT.
% 
%     The GridCAT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     The GridCAT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with the GridCAT.  If not, see <http://www.gnu.org/licenses/>.
%
%
% DEFINECONTRASTVECTOR_GUI MATLAB code for defineContrastVector_GUI.fig
%      DEFINECONTRASTVECTOR_GUI, by itself, creates a new DEFINECONTRASTVECTOR_GUI or raises the existing
%      singleton*.
%
%      H = DEFINECONTRASTVECTOR_GUI returns the handle to a new DEFINECONTRASTVECTOR_GUI or the handle to
%      the existing singleton*.
%
%      DEFINECONTRASTVECTOR_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DEFINECONTRASTVECTOR_GUI.M with the given input arguments.
%
%      DEFINECONTRASTVECTOR_GUI('Property','Value',...) creates a new DEFINECONTRASTVECTOR_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before defineContrastVector_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to defineContrastVector_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help defineContrastVector_GUI

% Last Modified by GUIDE v2.5 21-Oct-2016 09:35:23

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @defineContrastVector_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @defineContrastVector_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before defineContrastVector_GUI is made visible.
function defineContrastVector_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to defineContrastVector_GUI (see VARARGIN)

% Choose default command line output for defineContrastVector_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% ------------------------------------------------
% mst-edit:

% adapt position of the new GUI
adaptFigurePosition(hObject);

% Change font size of all GUI elements depending on current platform, if necessary 
ud = getUserData(hObject, 'UserData');
if ~isfield(ud, 'fontSizeAdapted') || ~ud.fontSizeAdapted
    changeFontSizesIfReq(handles, hObject);
end

% Make the GUI modal
set(handles.figure1,'WindowStyle', 'modal');

% change figure name
set(handles.figure1, 'Name', 'GridCAT - Define Contrast');

% Before the GUI is made visible, the table should show a list of
% all the available regressors and a second (empty) column.
regNameList = varargin{1};
regNameList = regNameList';
regNameList(:,2) = {''};
set(handles.uitable1, 'Data', regNameList);

drawnow

% ------------------------------------------------

% UIWAIT makes defineContrastVector_GUI_alt wait for user response (see UIRESUME)
uiwait(handles.figure1); % mst-edit


% --- Outputs from this function are returned to the command line.
function varargout = defineContrastVector_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% ------------------------------------------------
% mst-edit:
varargout{1} = [];
varargout{2} = [];
ud = getUserData(handles.uitable1, 'UserData');
if ~isempty(ud)
    varargout{1} = ud.contrastVector;
    varargout{2} = ud.contrastName;
end

delete(handles.figure1);
% ------------------------------------------------


% --- Executes on button press in pushbutton_OK.
function pushbutton_OK_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_OK (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% write contrast values (numeric) on user data of the table.
% all missing values are set to zero.
tableData = get(handles.uitable1, 'Data');
conValues = tableData(:,2);
conVec(1:length(conValues)) = NaN; % preallocating for speed
for regIdx = 1:length(conValues)
    conVec(regIdx) = str2double(conValues{regIdx});
end
conVec(isnan(conVec)) = 0;

ud.contrastVector = conVec;
ud.contrastName = get(handles.edit_contrastName, 'String');
set(handles.uitable1, 'UserData', ud);

close(handles.figure1);


% --- Executes on button press in pushbutton_Cancel.
function pushbutton_Cancel_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close(handles.figure1);


function edit_contrastName_Callback(hObject, eventdata, handles)
% hObject    handle to edit_contrastName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_contrastName as text
%        str2double(get(hObject,'String')) returns contents of edit_contrastName as a double


% --- Executes during object creation, after setting all properties.
function edit_contrastName_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_contrastName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
% delete(hObject); % mst-edit

% mst-edit:
if isequal(get(hObject, 'waitstatus'), 'waiting')
    uiresume(hObject);
else
    delete(hObject);
end
