function estimateGLM(cfg)
%
%     Copyright 2017 Matthias Stangl, Jonathan Shine, Thomas Wolbers
%     matthias.stangl@dzne.de, jonathan.shine@dzne.de, thomas.wolbers@dzne.de
% 
%     This file is part of the GridCAT.
% 
%     The GridCAT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     The GridCAT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with the GridCAT.  If not, see <http://www.gnu.org/licenses/>.
%
%
% Estimate an already specified GLM


%% LOAD GLM SPECIFICATIONS (cfg) FROM GridCAT_GLMx.mat FILE

GridCAT_file = [cfg.GLM.dataDir filesep 'GridCAT_GLM' num2str(cfg.GLMnr) '.mat'];
GridCAT_cfg = load(GridCAT_file);
cfg = GridCAT_cfg.cfg;


%% ESTIMATE GLM

spmModel_est(cfg);


%% PERFORM POST-GLM CALCULATIONS

if cfg.GLMnr == 1

    % Estimate grid orientation per voxel
    gridEventType = estimateGridOri_voxelwise(cfg);
    
    % Save results on mat-file (estimated voxelwise grid orientations etc.)
    save(GridCAT_file, 'cfg', 'gridEventType');
    
elseif cfg.GLMnr == 2
    
    % Create common contrasts between regressors that model grid events
	createDefaultContrastSet(cfg);
   
end






