function GUIdata = getDesignParameters(handles)
%
%     Copyright 2017 Matthias Stangl, Jonathan Shine, Thomas Wolbers
%     matthias.stangl@dzne.de, jonathan.shine@dzne.de, thomas.wolbers@dzne.de
% 
%     This file is part of the GridCAT.
% 
%     The GridCAT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     The GridCAT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with the GridCAT.  If not, see <http://www.gnu.org/licenses/>.
%
%

% Get necessary data to reconstruct GUI status
fieldRecord = fieldnames(guidata(handles.figure_GridCAT_GUI));
for elemIdx = 1:length(fieldRecord)
    if isprop(getfield(handles,fieldRecord{elemIdx}), 'String')
        element(elemIdx).String = get(getfield(handles,fieldRecord{elemIdx}),'String');
    end
    if isprop(getfield(handles,fieldRecord{elemIdx}), 'Value')
        element(elemIdx).Value = get(getfield(handles,fieldRecord{elemIdx}),'Value');
    end
    if isprop(getfield(handles,fieldRecord{elemIdx}), 'Enable')
        element(elemIdx).Enable = get(getfield(handles,fieldRecord{elemIdx}),'Enable');
    end
    if isprop(getfield(handles,fieldRecord{elemIdx}), 'Visible')
        element(elemIdx).Visible = get(getfield(handles,fieldRecord{elemIdx}),'Visible');
    end
    if isprop(getfield(handles,fieldRecord{elemIdx}), 'UserData')
        element(elemIdx).UserData = get(getfield(handles,fieldRecord{elemIdx}),'UserData');
    end
    if isprop(getfield(handles,fieldRecord{elemIdx}), 'Data')
        element(elemIdx).Data = get(getfield(handles,fieldRecord{elemIdx}),'Data');
    end
end
GUIdata.fieldRecord = fieldRecord;
GUIdata.element = element;