function varargout = gridcat(varargin)
%
%     Copyright 2017 Matthias Stangl, Jonathan Shine, Thomas Wolbers
%     matthias.stangl@dzne.de, jonathan.shine@dzne.de, thomas.wolbers@dzne.de
% 
%     This file is part of the GridCAT.
% 
%     The GridCAT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     The GridCAT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with the GridCAT.  If not, see <http://www.gnu.org/licenses/>.
%
%
% GRIDCAT MATLAB code for gridcat.fig
%      GRIDCAT, by itself, creates a new GRIDCAT or raises the existing
%      singleton*.
%
%      H = GRIDCAT returns the handle to a new GRIDCAT or the handle to
%      the existing singleton*.
%
%      GRIDCAT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GRIDCAT.M with the given input arguments.
%
%      GRIDCAT('Property','Value',...) creates a new GRIDCAT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gridcat_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gridcat_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gridcat

% Last Modified by GUIDE v2.5 13-Dec-2016 12:38:10

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gridcat_OpeningFcn, ...
                   'gui_OutputFcn',  @gridcat_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before gridcat is made visible.
function gridcat_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gridcat (see VARARGIN)

% Choose default command line output for gridcat
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% ------------------------------------------------
% mst-edit:

% Change font size of all GUI elements depending on current platform, if necessary
ud = getUserData(hObject, 'UserData');
if ~isfield(ud, 'fontSizeAdapted') || ~ud.fontSizeAdapted
    changeFontSizesIfReq(handles, hObject);
end

% change figure name to the first line in the document GridCAT_VersionInfo
fp = fopen('GridCAT_VersionInfo.txt');
set(handles.figure_GridCAT_GUI, 'Name', fgetl(fp));

% set figure tag
set(handles.figure_GridCAT_GUI, 'Tag', 'GridCAT - main figure');

% Write defaut-values on user  data of the main figure
ud = getUserData(handles.figure_GridCAT_GUI, 'UserData');
ud.advancedModelSettings.HPF_str = '128';
ud.advancedModelSettings.maskingThreshold = 0.8;
ud.advancedModelSettings.microtimeResolution = 16;
ud.advancedModelSettings.microtimeOnset = 8;
ud.advancedModelSettings.derivatives = [0 0];
set(handles.figure_GridCAT_GUI, 'UserData', ud);

drawnow

% ------------------------------------------------

% UIWAIT makes gridcat wait for user response (see UIRESUME)
% uiwait(handles.figure_GridCAT_GUI);


% --- Outputs from this function are returned to the command line.
function varargout = gridcat_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes when selected cell(s) is changed in uitable_filelist.
function uitable_filelist_CellSelectionCallback(hObject, eventdata, handles)
% hObject    handle to uitable_filelist (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) currently selecteds
% handles    structure with handles and user data (see GUIDATA)

% write indices of currently selected cell(s) on UserData
ud = getUserData(handles.uitable_filelist, 'UserData');
ud.selectedCells = eventdata.Indices;
set(handles.uitable_filelist, 'UserData', ud);


% --- Executes on button press in pushbutton_addFilelistLine.
function pushbutton_addFilelistLine_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_addFilelistLine (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% add another line (i.e. run) to the filelist table
tableData = get(handles.uitable_filelist, 'Data');
tableData(end+1,:) = {[repmat(' ', 1,6) num2str(size(tableData,1)+1)], '', '', ''};
set(handles.uitable_filelist, 'Data', tableData);

drawnow


% --- Executes on button press in pushbutton_deleteFilelistLine.
function pushbutton_deleteFilelistLine_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_deleteFilelistLine (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% delete last run if there is more than one left
tableData = get(handles.uitable_filelist, 'Data');
deleteRunNr = size(tableData,1);

% check whether the last line of the table (i.e., the line that should be deleted) is empty
if deleteRunNr > 1 && (~isempty(tableData{deleteRunNr,2}) || ~isempty(tableData{deleteRunNr,3}) || ~isempty(tableData{deleteRunNr,4}))
    
    % ask for permission to delete, because the line is not empty
    permissionToDelete = questdlg_GUI({sprintf('Data has already been specified for the run you want to delete.\nDelete anyway?')}, 'No', 'Yes');
    
    % do not delete (end this function) if user did not give permission to delete
    if ~strcmp(permissionToDelete, 'Yes')
        return
    end
end

if deleteRunNr > 1
    
    % delete the last line (i.e. run) from the filelist table
    tableData(deleteRunNr,:) = [];
    set(handles.uitable_filelist, 'Data', tableData);
    
    % delete the last line (i.e. run) from the UserData
    ud = getUserData(handles.uitable_filelist, 'UserData');
    if isfield(ud, 'run') && (deleteRunNr <= length(ud.run))
        ud.run(deleteRunNr) = [];
        set(handles.uitable_filelist, 'UserData', ud);
    end  
end

drawnow


% --- Executes on button press in pushbutton_addFilelistContent.
function pushbutton_addFilelistContent_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_addFilelistContent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% load UserData
ud = getUserData(handles.uitable_filelist, 'UserData');

% get tableData
tableData = get(handles.uitable_filelist, 'Data');

% which cells should be filled with data?
if isfield(ud, 'selectedCells') && ~isempty(ud.selectedCells)
    % just specific cells are selected by the user, so we fill only these cells
    cellsToFill = ud.selectedCells;
else
    % no specific cells are selected by the user, so we fill all cells that are empty
    [emptyRows, emptyCols] = ind2sub(size(tableData),find(cellfun(@isempty,tableData)));
    if size(emptyRows,1)<size(emptyRows,2)
        emptyRows = emptyRows';
        emptyCols = emptyCols';
    end
    cellsToFill = [emptyRows, emptyCols];    
end

% only continue function, if there are cells that need to be filled
if isempty(cellsToFill)
    return
end

% in which order should the cells be filled?
% first rows then columns: sortrows(cellsToFill,1);
% first columns then rows: sortrows(cellsToFill,2);
cellsToFill = sortrows(cellsToFill,1);
  
for cellToFillIdx = 1:size(cellsToFill,1)

    curCellIds = cellsToFill(cellToFillIdx,:);

    switch curCellIds(2) % columnNr of selected cell

        case 2
            % --------------------------------------------
            % Add functional scans
            % --------------------------------------------

            % open file selection dialog
            newFiles = selectionDlg_GUI({'getFile'}, ['Select functional scans for run ' num2str(curCellIds(1))], pwd, {'*'}, 0, [1 inf], 'off', 1, 'GridCAT - main figure', {'.nii', '.img'}, 'on');

            % if files have been selected
            if ~isempty(newFiles)

                % Append new files to UserData
                ud.run(curCellIds(1)).functionalScans = newFiles;
                set(handles.uitable_filelist, 'UserData', ud);

                % Visualization in cell
                [~,file1_name, file1_ext] = fileparts(newFiles{1});
                visStr = ['(' num2str(length(newFiles)) ' files) ' file1_name file1_ext];
                tableData = get(handles.uitable_filelist, 'Data');
                tableData{curCellIds(1), curCellIds(2)} = visStr;
                set(handles.uitable_filelist, 'Data', tableData);
            else
                return;
            end

        case 3
            % --------------------------------------------
            % Add event-table
            % --------------------------------------------

            % open file selection dialog
            newFile = selectionDlg_GUI({'getFile'}, ['Select event-table for run ' num2str(curCellIds(1))], pwd, {'*'}, 0, [1 1], 'off', 0, 'GridCAT - main figure', {'.txt'}, 'on');

            % if file has been selected
            if ~isempty(newFile)

                % Append new file to UserData
                ud.run(curCellIds(1)).eventTable = newFile{1};
                set(handles.uitable_filelist, 'UserData', ud);

                % Visualization in cell
                tableData = get(handles.uitable_filelist, 'Data');
                [~, filename, fext] = fileparts(newFile{1});
                tableData{curCellIds(1), curCellIds(2)} = [filename fext];
                set(handles.uitable_filelist, 'Data', tableData);
            else
                return;
            end

        case 4
            % --------------------------------------------
            % Add additional regressors file
            % --------------------------------------------

            % open file selection dialog
            newFile = selectionDlg_GUI({'getFile'}, ['Select additional regressors file for run ' num2str(curCellIds(1))], pwd, {'*'}, 0, [1 1], 'off', 0, 'GridCAT - main figure', {'.txt', '.mat'}, 'on');

            % if file has been selected
            if ~isempty(newFile)

                % Append new file to UserData
                ud.run(curCellIds(1)).additionalRegressorsFile = newFile{1};
                set(handles.uitable_filelist, 'UserData', ud);

                % Visualization in cell
                tableData = get(handles.uitable_filelist, 'Data');
                [~, filename, fext] = fileparts(newFile{1});
                tableData{curCellIds(1), curCellIds(2)} = [filename fext];
                set(handles.uitable_filelist, 'Data', tableData);
            else
                return;
            end          
    end

    drawnow

end



% --- Executes on button press in pushbutton_displayFilelistContent.
function pushbutton_displayFilelistContent_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_displayFilelistContent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% load UserData
ud = getUserData(handles.uitable_filelist, 'UserData');

% get tableData
tableData = get(handles.uitable_filelist, 'Data');

% display the content for the selected cell
if ~isfield(ud, 'selectedCells') || isempty(ud.selectedCells)
    
    % no specific cells are selected by the user, so we display all cells that are not empty
    [notEmptyRows, notEmptyCols] = ind2sub(size(tableData),find(~cellfun(@isempty,tableData)));
    if size(notEmptyRows,1)<size(notEmptyRows,2)
        notEmptyRows = notEmptyRows';
        notEmptyCols = notEmptyCols';
    end
    cellsToDisplay = [notEmptyRows, notEmptyCols];
    
else
    cellsToDisplay = ud.selectedCells;
end

% only continue function, if there are cells to be displayed
if isempty(cellsToDisplay)
    return
end

% in which order should the cells be displayed?
% first rows then columns: sortrows(cellsToFill,1);
% first columns then rows: sortrows(cellsToFill,2);
cellsToDisplay = sortrows(cellsToDisplay,1);

output = {};

for cellToDisplayIdx = 1:size(cellsToDisplay,1)

    curCellIds = cellsToDisplay(cellToDisplayIdx,:);

    if isfield(ud, 'run') && length(ud.run)>=curCellIds(1)

        switch curCellIds(2) % columnNr of selected cell

            case 2
                % display functional scans
                if isfield(ud.run(curCellIds(1)), 'functionalScans') && ~isempty(ud.run(curCellIds(1)).functionalScans)
                    output{end+1} = ['Run ' num2str(curCellIds(1)) ', functional scans (' num2str(length(ud.run(curCellIds(1)).functionalScans)) ' files):'];
                    output = [output strcat({'        '}, ud.run(curCellIds(1)).functionalScans)'];
                    output{end+1} = ' ';
                end

            case 3
                % display event-table
                if isfield(ud.run(curCellIds(1)), 'eventTable') && ~isempty(ud.run(curCellIds(1)).eventTable)
                    output{end+1} = ['Run ' num2str(curCellIds(1)) ', event-table:'];
                    output = [output strcat({'        '}, ud.run(curCellIds(1)).eventTable)'];
                    output{end+1} = ' ';
                end

            case 4
                % display additional regressors file
                if isfield(ud.run(curCellIds(1)), 'additionalRegressorsFile') && ~isempty(ud.run(curCellIds(1)).additionalRegressorsFile)
                    output{end+1} = ['Run ' num2str(curCellIds(1)) ', additional regressors:'];
                    output = [output strcat({'        '}, ud.run(curCellIds(1)).additionalRegressorsFile)'];
                    output{end+1} = ' ';
                end
        end
    end
end

% GUI with listbox
output_GUI(output')
    


% --- Executes on button press in pushbutton_deleteFilelistContent.
function pushbutton_deleteFilelistContent_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_deleteFilelistContent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% load tableData and UserData
ud = getUserData(handles.uitable_filelist, 'UserData');
tableData = get(handles.uitable_filelist, 'Data');

if isfield(ud, 'selectedCells')
    
    for selectedCellIdx = 1:size(ud.selectedCells,1)

        curCellIds = ud.selectedCells(selectedCellIdx,:);

        if isfield(ud, 'run') && length(ud.run)>=curCellIds(1)
        
            % delete tableData cell
            if curCellIds(2) ~= 1
                tableData{curCellIds(1), curCellIds(2)} = ''; 
            end

            switch curCellIds(2) % columnNr of selected cell

                case 2
                    % delete functional scans
                    if isfield(ud.run(curCellIds(1)), 'functionalScans')
                        ud.run(curCellIds(1)).functionalScans = [];
                    end

                case 3
                    % delete event-table
                    if isfield(ud.run(curCellIds(1)), 'eventTable')
                        ud.run(curCellIds(1)).eventTable = [];
                    end                

                case 4
                    % delete additional regressors file
                    if isfield(ud.run(curCellIds(1)), 'additionalRegressorsFile')
                        ud.run(curCellIds(1)).additionalRegressorsFile = [];
                    end                        
            end
        end
    end
end

% save tableData and UserData
set(handles.uitable_filelist, 'Data', tableData);
set(handles.uitable_filelist, 'UserData', ud);

drawnow


% --- Executes on button press in pushbutton_saveDesignParameters.
function pushbutton_saveDesignParameters_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_saveDesignParameters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% get design parameters
cfg.GUIdata = getDesignParameters(handles);

% specify destination of design parameters file
saveToPath = selectionDlg_GUI({'putFile'}, 'Save design parameters...', pwd, {'*'}, 0, [1 1], 'on', 0, 'GridCAT - main figure', {'.mat'}, 'on', 'GridCAT_designParam.mat');

% Save design parameters
if ~isempty(saveToPath)
    save([saveToPath{1}],'cfg');    
    disp(['Design parameters saved to: ' saveToPath{1}]);
end


% --- Executes on button press in pushbutton_loadDesignParameters.
function pushbutton_loadDesignParameters_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_loadDesignParameters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

loadDesignParameters(handles);

% reset selected cells in filelist
ud_table = getUserData(handles.uitable_filelist, 'UserData');
ud_table.selectedCells = [];
set(handles.uitable_filelist, 'UserData', ud_table);


% --- Executes on button press in pushbutton_selectDataDir_GLM1.
function pushbutton_selectDataDir_GLM1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_selectDataDir_GLM1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

newDir = selectionDlg_GUI({'getDir'}, 'Select directory for GLM1 data', pwd, {'*'}, 0, [1 1], 'on', 0, 'GridCAT - main figure');

if ~isempty(newDir)
    updatePathData(handles.text_dataDirPath_GLM1, newDir);
end


% --- Executes on button press in pushbutton_selectDataDir_GLM2.
function pushbutton_selectDataDir_GLM2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_selectDataDir_GLM2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

newDir = selectionDlg_GUI({'getDir'}, 'Select directory for GLM2 data', pwd, {'*'}, 0, [1 1], 'on', 0, 'GridCAT - main figure');

if ~isempty(newDir)
    updatePathData(handles.text_dataDirPath_GLM2, newDir);
end


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over text_dataDirPath_GLM1.
function text_dataDirPath_GLM1_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to text_dataDirPath_GLM1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ~isempty(getUserData(handles.text_dataDirPath_GLM1, 'UserData'))
    h = msgbox(getUserData(handles.text_dataDirPath_GLM1, 'UserData'), 'GLM1 data directory');
    adaptFigurePosition(h);
end


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over text_dataDirPath_GLM2.
function text_dataDirPath_GLM2_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to text_dataDirPath_GLM2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ~isempty(getUserData(handles.text_dataDirPath_GLM2, 'UserData'))
    h = msgbox(getUserData(handles.text_dataDirPath_GLM2, 'UserData'), 'GLM2 data directory');
    adaptFigurePosition(h);
end


function edit_TR_Callback(hObject, eventdata, handles)
% hObject    handle to edit_TR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_TR as text
%        str2double(get(hObject,'String')) returns contents of edit_TR as a double


% --- Executes during object creation, after setting all properties.
function edit_TR_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_TR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_changeAdvancedModelSettings.
function pushbutton_changeAdvancedModelSettings_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_changeAdvancedModelSettings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% load default settings from user data of main figure (specified at GUI opening).
ud = getUserData(handles.figure_GridCAT_GUI, 'UserData');

% open dialog to change settings
newSettings = changeAdvancedModelSettings_GUI(ud.advancedModelSettings);

% save new settings if the user closed the dialog with OK
if ~isempty(newSettings)
    ud.advancedModelSettings = newSettings;
    set(handles.figure_GridCAT_GUI, 'UserData', ud);
end

% display new settings in cmd window
ud = getUserData(handles.figure_GridCAT_GUI, 'UserData');
disp(' ');
disp(ud.advancedModelSettings);


% --- Executes on selection change in popupmenu_xFoldSymmetry.
function popupmenu_xFoldSymmetry_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_xFoldSymmetry (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_xFoldSymmetry contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_xFoldSymmetry

if get(handles.popupmenu_xFoldSymmetry, 'Value') == 1
    set(handles.edit_xFoldSymmetry, 'String', 6)
    set(handles.edit_xFoldSymmetry, 'Enable', 'off')
else
    set(handles.edit_xFoldSymmetry, 'String', '')
    set(handles.edit_xFoldSymmetry, 'Enable', 'on')
end

drawnow


% --- Executes during object creation, after setting all properties.
function popupmenu_xFoldSymmetry_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_xFoldSymmetry (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_xFoldSymmetry_Callback(hObject, eventdata, handles)
% hObject    handle to edit_xFoldSymmetry (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_xFoldSymmetry as text
%        str2double(get(hObject,'String')) returns contents of edit_xFoldSymmetry as a double


% --- Executes during object creation, after setting all properties.
function edit_xFoldSymmetry_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_xFoldSymmetry (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox_keepUnusedEvents_GLM1.
function checkbox_keepUnusedEvents_GLM1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_keepUnusedEvents_GLM1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_keepUnusedEvents_GLM1


% --- Executes on selection change in popupmenu_dataSelection_GLM1.
function popupmenu_dataSelection_GLM1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_dataSelection_GLM1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_dataSelection_GLM1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_dataSelection_GLM1

% which option is currently selected?
currentSelection = get(handles.popupmenu_dataSelection_GLM1, 'Value');

% change selection in testGridOri-popupmenu depending on selection in esimateGridOri-popupmenu
if any(currentSelection == [1 8 9])
    % no selection yet, or line 8 (use all events) or 9 (get specification from event-table) ist selected
    set(handles.popupmenu_dataSelection_GLM2, 'Value', currentSelection);
elseif mod(currentSelection,2) 
    % an odd line is selected
    set(handles.popupmenu_dataSelection_GLM2, 'Value', currentSelection-1);
else 
    % an even line is selected
    set(handles.popupmenu_dataSelection_GLM2, 'Value', currentSelection+1);
end

drawnow


% --- Executes during object creation, after setting all properties.
function popupmenu_dataSelection_GLM1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_dataSelection_GLM1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_computeGLM1.
function popupmenu_computeGLM1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_computeGLM1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_computeGLM1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_computeGLM1


% --- Executes during object creation, after setting all properties.
function popupmenu_computeGLM1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_computeGLM1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_computeGLM1.
function pushbutton_computeGLM1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_computeGLM1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% collect user input from GUI and create cfg-variable that will then be used for calculations
cfg = designParameters2cfg(handles, 1);

% stop computations if parameters are not specified correcly
if isempty(cfg)
    return
end

% has the user selected to specify the model?
if any(get(handles.popupmenu_computeGLM1, 'Value') ==  [1 2])

    % Create SPM window for graphical output (e.g. progress bar)
    hfig = setInteractiveWindow_SPM('GLM1 is specified. Please be patient.');
    
    % specify model
    specifyGLM(cfg);
    
    % Clear SPM window
    spm_figure('Clear', hfig);
end

% has the user selected to estimate the model?
if any(get(handles.popupmenu_computeGLM1, 'Value') ==  [1 3])
    
    % Create SPM window for graphical output (e.g. progress bar)
    hfig = setInteractiveWindow_SPM('GLM1 is estimated. Please be patient.');
    
    % estimate model
    estimateGLM(cfg);
end

% Close SPM window
close(hfig);


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over text_maskImg_meanGridOri.
function text_maskImg_meanGridOri_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to text_maskImg_meanGridOri (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ~isempty(getUserData(handles.text_maskImg_meanGridOri, 'UserData'))
    h = msgbox(getUserData(handles.text_maskImg_meanGridOri, 'UserData'), 'ROI mask:');
    adaptFigurePosition(h);
end


% --- Executes on button press in pushbutton_selectMaskForMeanGridOriCalculation.
function pushbutton_selectMaskForMeanGridOriCalculation_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_selectMaskForMeanGridOriCalculation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

newImg = selectionDlg_GUI({'getFile'}, 'Select ROI mask', pwd, {'*'}, 0, [1 1], 'off', 1, 'GridCAT - main figure', {'.nii', '.img'}, 'on');

if ~isempty(newImg)
    updatePathData(handles.text_maskImg_meanGridOri, newImg);
end


% --- Executes on button press in checkbox_useWeightingForVoxels.
function checkbox_useWeightingForVoxels_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_useWeightingForVoxels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_useWeightingForVoxels


% --- Executes on button press in checkbox_averageMeanGridOriAcrossRuns.
function checkbox_averageMeanGridOriAcrossRuns_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_averageMeanGridOriAcrossRuns (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_averageMeanGridOriAcrossRuns


% --- Executes on selection change in popupmenu_gridRegressors.
function popupmenu_gridRegressors_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_gridRegressors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_gridRegressors contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_gridRegressors


% --- Executes during object creation, after setting all properties.
function popupmenu_gridRegressors_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_gridRegressors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_dataSelection_GLM2.
function popupmenu_dataSelection_GLM2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_dataSelection_GLM2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_dataSelection_GLM2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_dataSelection_GLM2


% --- Executes during object creation, after setting all properties.
function popupmenu_dataSelection_GLM2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_dataSelection_GLM2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox_keepUnusedEvents_GLM2.
function checkbox_keepUnusedEvents_GLM2_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_keepUnusedEvents_GLM2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_keepUnusedEvents_GLM2


% --- Executes on selection change in popupmenu_computeGLM2.
function popupmenu_computeGLM2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_computeGLM2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_computeGLM2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_computeGLM2


% --- Executes during object creation, after setting all properties.
function popupmenu_computeGLM2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_computeGLM2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_computeGLM2.
function pushbutton_computeGLM2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_computeGLM2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% has the user selected to specify and estimate both GLM1 and GLM2 together?
if get(handles.popupmenu_computeGLM2, 'Value') ==  4
    
    % collect user input from GUI and create cfg-variable that will then be used for calculations
    cfg = designParameters2cfg(handles, 1);
    
    % stop computations if parameters are not specified correcly
    if isempty(cfg)
        return
    end

    % Specify and estimate GLM1
    hfig = setInteractiveWindow_SPM('GLM1 is specified. Please be patient.');    
    specifyGLM(cfg);
    spm_figure('Clear', hfig);
    hfig = setInteractiveWindow_SPM('GLM1 is estimated. Please be patient.'); 
    estimateGLM(cfg);
    spm_figure('Clear', hfig);
end

% collect user input from GUI and create cfg-variable that will then be used for calculations
cfg = designParameters2cfg(handles, 2);

% stop computations if parameters are not specified correcly
if isempty(cfg)
    return
end

% has the user selected to specify the model?
if any(get(handles.popupmenu_computeGLM2, 'Value') ==  [1 2 4])

    % Create SPM window for graphical output (e.g. progress bar)
    hfig = setInteractiveWindow_SPM('GLM2 is specified. Please be patient.');
    
    % specify model
    specifyGLM(cfg);
    
    % Clear SPM window
    spm_figure('Clear', hfig);
end

% has the user selected to estimate the model?
if any(get(handles.popupmenu_computeGLM2, 'Value') ==  [1 3 4])
    
    % Create SPM window for graphical output (e.g. progress bar)
    hfig = setInteractiveWindow_SPM('GLM2 is estimated. Please be patient.');
    
    % estimate model
    estimateGLM(cfg);
end

% Close SPM window
close(hfig);


% --- Executes on selection change in popupmenu_toolsAndGridMetrics.
function popupmenu_toolsAndGridMetrics_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_toolsAndGridMetrics (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_toolsAndGridMetrics contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_toolsAndGridMetrics

% which options (i.e. lines of the popupmenu) should enable selecting a ROI mask-image?
optionsWhichEnableMaskSelection = [2 3 4 6 7];

% which option is currently selected?
currentlySelectedOption = get(handles.popupmenu_toolsAndGridMetrics, 'Value');

% enable/disable selecting a ROI mask-image
if  any(currentlySelectedOption == optionsWhichEnableMaskSelection)
    set(handles.pushbutton_selectMaskForToolsAndGridMetrics, 'Enable', 'on');
    set(handles.text_maskImg_toolsAndGridMetrics, 'Enable', 'inactive');
else
    set(handles.pushbutton_selectMaskForToolsAndGridMetrics, 'Enable', 'off');
    set(handles.text_maskImg_toolsAndGridMetrics, 'Enable', 'off');
end
    
drawnow


% --- Executes during object creation, after setting all properties.
function popupmenu_toolsAndGridMetrics_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_toolsAndGridMetrics (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_selectMaskForToolsAndGridMetrics.
function pushbutton_selectMaskForToolsAndGridMetrics_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_selectMaskForToolsAndGridMetrics (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

newImg = selectionDlg_GUI({'getFile'}, 'Select one or multiple ROI masks', pwd, {'*'}, 0, [1 inf], 'off', 1, 'GridCAT - main figure', {'.nii', '.img'}, 'on');

if ~isempty(newImg)
    updatePathData(handles.text_maskImg_toolsAndGridMetrics, newImg);
end

drawnow


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over text_maskImg_toolsAndGridMetrics.
function text_maskImg_toolsAndGridMetrics_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to text_maskImg_toolsAndGridMetrics (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ~isempty(getUserData(handles.text_maskImg_toolsAndGridMetrics, 'UserData'))
    h = msgbox(getUserData(handles.text_maskImg_toolsAndGridMetrics, 'UserData'), 'ROI mask-image');
    adaptFigurePosition(h);
end


% --- Executes on button press in pushbutton_computeToolsAndGridMetrics.
function pushbutton_computeToolsAndGridMetrics_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_computeToolsAndGridMetrics (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Which tool or grid metric should be calculated?
selectedOption = get(handles.popupmenu_toolsAndGridMetrics, 'Value');

% For some tools or grid metrics it is necessary to specify one or multiple ROI mask images
% for which the output should be calculated
if any(selectedOption == [2 3 4 6 7])
    
    % get 1:n paths to ROI mask-images, for which the output visualization is processed
    roiMaskImages_outputGridMetric = getUserData(handles.text_maskImg_toolsAndGridMetrics, 'UserData'); % must be aligned with the (mean)EPI images

    % Check whether at least one ROI mask image has been specified
    if isempty(roiMaskImages_outputGridMetric)

        % No ROI mask image specified
        h = msgbox(sprintf('Please specify one or multiple ROI mask images for which the output should be calculated.'));
        adaptFigurePosition(h);
        return

    end
end

switch selectedOption

    
    case 1
        
        % ----------------------------------------------------------------
        % Display design
        % ----------------------------------------------------------------         
        
        % Which model should be reviewed (GLM1 or GLM2)?
        chosenGLM = questdlg_GUI({sprintf('\nWhich GLM do you want to display?')}, 'GLM1', 'GLM2');

        % get path to SPM.mat
        if strcmp(chosenGLM, 'GLM1')
            SPMmatFile = [cell2mat(getUserData(handles.text_dataDirPath_GLM1, 'UserData')) filesep 'SPM.mat'];
        elseif strcmp(chosenGLM, 'GLM2')
            SPMmatFile = [cell2mat(getUserData(handles.text_dataDirPath_GLM2, 'UserData')) filesep 'SPM.mat'];
        else
            return
        end
      
        % Check whether SPM.mat file can be found
        if ~exist(SPMmatFile, 'file')

            % SPM mat file does not exist
            h = msgbox(sprintf('SPM.mat file not found.\n\nPlease specify the data directory of an already computed GLM in the ''GLM data directories'' panel.'));
            adaptFigurePosition(h);
            
        else
            
            % display design with SPM
            displayDesign_SPM(SPMmatFile);

        end
        
        drawnow
 
        
    case 2
        
        % ----------------------------------------------------------------
        % Between-voxels grid orientation coherence within ROI
        % ----------------------------------------------------------------
        
        % Check whether at least one voxelwise ori image can be found
        availableImages = dir([cell2mat(getUserData(handles.text_dataDirPath_GLM1, 'UserData')) filesep 'voxelwiseGridOri*.nii']);
        if isempty(availableImages)

            % No voxelwise ori image found
            h = msgbox(sprintf('No voxel-wise grid orientation image found.\n\nThese images are automatically generated by the GridCAT during GLM1 calculations and saved in the GLM1 data directory. Please specify a valid GLM1 data directory in the ''GLM data directories'' panel.'));
            adaptFigurePosition(h);
            
        else
            
            % open file selection dialog to select 1:n images with voxelwise grid orientations
            voxelwiseOriImages = selectionDlg_GUI({'getFile'}, 'Select images containing voxel-wise grid orientations', cell2mat(getUserData(handles.text_dataDirPath_GLM1, 'UserData')), {'voxelwiseGridOri*.nii'}, 1, [1 inf], 'off', 0, 'GridCAT - main figure', {'.nii'}, 'on');

            % if files have been selected
            if ~isempty(voxelwiseOriImages)
                
                % which xFoldSymmetry were the calculations testing for?
                GridCAT_matFileData = load([cell2mat(getUserData(handles.text_dataDirPath_GLM1, 'UserData')) filesep 'GridCAT_GLM1.mat']);
                xFoldSymmetry = GridCAT_matFileData.cfg.GLM.xFoldSymmetry;

                % the GUI is opened separately for each ROI mask
                for maskIdx = 1:length(roiMaskImages_outputGridMetric)

                    % the GUI is opened separately for each voxel-wise ori image
                    for voxelwiseOriImgIdx = 1:length(voxelwiseOriImages)

                        % calculate grid metric
                        oriCoherence_betweenVox_GUI(1, roiMaskImages_outputGridMetric(maskIdx), voxelwiseOriImages(voxelwiseOriImgIdx), xFoldSymmetry);
                        
                    end
                end
            end
        end
        
        
    case 3
        
        % ----------------------------------------------------------------
        % Within-voxels grid orientation coherence within ROI
        % ----------------------------------------------------------------

        % Check whether at least two voxelwise ori images can be found
        availableImages = dir([cell2mat(getUserData(handles.text_dataDirPath_GLM1, 'UserData')) filesep 'voxelwiseGridOri*.nii']);
        if length(availableImages) < 2

            % Less than 2 voxelwise ori image found
            h = msgbox(sprintf('Voxel-wise grid orientation images not found.\n\nThese images are automatically generated by the GridCAT during GLM1 calculations and saved in the GLM1 data directory. Please specify a valid GLM1 data directory in the ''GLM data directories'' panel.'));
            adaptFigurePosition(h);
            
        else
        
            % open file selection dialog to select 2 images with voxelwise grid orientations
            voxelwiseOriImages = selectionDlg_GUI({'getFile'}, 'Select two images containing voxel-wise grid orientations', cell2mat(getUserData(handles.text_dataDirPath_GLM1, 'UserData')), {'voxelwiseGridOri*.nii'}, 1, [2 2], 'off', 0, 'GridCAT - main figure', {'.nii'}, 'on');

            % if files have been selected
            if ~isempty(voxelwiseOriImages)    

                % which xFoldSymmetry were the calculations testing for?
                GridCAT_matFileData = load([cell2mat(getUserData(handles.text_dataDirPath_GLM1, 'UserData')) filesep 'GridCAT_GLM1.mat']);
                xFoldSymmetry = GridCAT_matFileData.cfg.GLM.xFoldSymmetry;

                % the GUI is opened separately for each ROI mask
                for maskIdx = 1:length(roiMaskImages_outputGridMetric)

                    % calculate grid metric just for the current ROI mask image
                    oriCoherence_withinVox_GUI(1, roiMaskImages_outputGridMetric(maskIdx), voxelwiseOriImages, xFoldSymmetry);
                end
            end
        end

        
    case 4
        
        % ----------------------------------------------------------------
        % Mean grid orientation within ROI
        % ----------------------------------------------------------------
        
        % Check whether at a GridCAT_GLM1.mat file can be found
        if ~exist([cell2mat(getUserData(handles.text_dataDirPath_GLM1, 'UserData')) filesep 'GridCAT_GLM1.mat'], 'file')

            % GridCAT_GLM1.mat not found
            h = msgbox(sprintf('GridCAT_GLM1.mat file not found.\n\nThis file is automatically generated by the GridCAT during GLM1 calculations and saved in the GLM1 data directory. Please specify a valid GLM1 data directory in the ''GLM data directories'' panel.'));
            adaptFigurePosition(h);        
            
        else
            GLM1output = load([cell2mat(getUserData(handles.text_dataDirPath_GLM1, 'UserData')) filesep 'GridCAT_GLM1.mat']);

            % calculate mean grid orientation within ROI for all grid events that are stored in GridCAT_GLM1.mat
            gridMetric_meanGridOriWithinROI(1, roiMaskImages_outputGridMetric, GLM1output);
        end
        
        
   case 5
        
        % ----------------------------------------------------------------
        % Create contrast between regressors
        % ----------------------------------------------------------------         
        
        % Get a list of all regressors from SPM.mat (GLM2)
        SPMmatFile = [cell2mat(getUserData(handles.text_dataDirPath_GLM2, 'UserData')) filesep 'SPM.mat'];

        % Check whether SPM.mat file can be found
        if ~exist(SPMmatFile, 'file')

            % SPM mat file does not exist
            h = msgbox(sprintf('SPM.mat file not found.\n\nPlease specify a valid GLM2 data directory in the ''GLM data directories'' panel.'));
            adaptFigurePosition(h);
            
        else
        
            % generate list of all regressors in the GLM
            SPMmatFileInfo = load(SPMmatFile);
            for regIdx = 1:length(SPMmatFileInfo.SPM.Vbeta)
                regNameList{regIdx} = SPMmatFileInfo.SPM.Vbeta(regIdx).descrip;
            end

            % open dialog to select regressors for contrast
            [contrastVector, contrastName] = defineContrastVector_GUI(regNameList);

            drawnow

            % if a contrast was defined properly, generate it with SPM
            if ~isempty(contrastVector)
                disp(['Generate new contrast (' contrastName '): ' num2str(contrastVector)]);
                generateContrastImage_SPM(SPMmatFile, contrastVector, contrastName) 
            end
        end
    
        
    case 6 
        
        % ----------------------------------------------------------------
        % Magnitude of grid code response within ROI
        % ----------------------------------------------------------------
        
        % Select, for which contrasts (that are defined in SPM.mat) the grid metrics should be calculated
        GLM2dataDir = cell2mat(getUserData(handles.text_dataDirPath_GLM2, 'UserData'));
        SPMmatFile = [GLM2dataDir filesep 'SPM.mat'];

        % Check whether SPM.mat file can be found
        if ~exist(SPMmatFile, 'file')

            % SPM mat file does not exist
            h = msgbox(sprintf('SPM.mat file not found.\n\nPlease specify a valid GLM2 data directory in the ''GLM data directories'' panel.'));
            adaptFigurePosition(h);

        else

            SPMmatFileInfo = load([GLM2dataDir filesep 'SPM.mat']);
            conNameList = [];
            for conIdx = 1:length(SPMmatFileInfo.SPM.xCon)
                conNameList{conIdx} = SPMmatFileInfo.SPM.xCon(conIdx).name;
            end

            % If there are no contrasts specified yet, this metric cannot be calculated.
            if isempty(conNameList)
                h = msgbox('There are no contrasts specified yet.');
                adaptFigurePosition(h);
                return
            end

            % for which contrast (e.g. which run) do I want to show results?
            [conNrOfInterest] = listdlg_GUI(conNameList, 'Select contrasts of interest:', 'multiselect');

            if ~isempty(conNrOfInterest)

                gridMetric_gridCodeResponseMagnitude(1, roiMaskImages_outputGridMetric, GLM2dataDir, conNrOfInterest);

            end
        end

        
    case 7
        
        % ----------------------------------------------------------------
        % Export all grid metrics
        % ----------------------------------------------------------------   
        
        % Check whether a GridCAT_GLM1.mat or GridCAT_GLM2.mat file can be found,
        % as an indicator of whether one or both GLMs have been computed and valid
        % GLM data directories have been specified
        if ~exist([cell2mat(getUserData(handles.text_dataDirPath_GLM1, 'UserData')) filesep 'GridCAT_GLM1.mat'], 'file') && ~exist([cell2mat(get(handles.text_dataDirPath_GLM2, 'UserData')) filesep 'GridCAT_GLM2.mat'], 'file')

            % Neither GridCAT_GLM1.mat nor GridCAT_GLM2.mat found
            h = msgbox(sprintf('Please specify valid data directories for GLM1 and/or GLM2 in the ''GLM data directories'' panel.'));
            adaptFigurePosition(h);     
            
        else
            
            % Export all grid metrics
            gridMetric_export(roiMaskImages_outputGridMetric, cell2mat(getUserData(handles.text_dataDirPath_GLM1, 'UserData')), cell2mat(get(handles.text_dataDirPath_GLM2, 'UserData')));
        end
        
end
