function varargout = inputdlg_GUI(varargin)
%
%     Copyright 2017 Matthias Stangl, Jonathan Shine, Thomas Wolbers
%     matthias.stangl@dzne.de, jonathan.shine@dzne.de, thomas.wolbers@dzne.de
% 
%     This file is part of the GridCAT.
% 
%     The GridCAT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     The GridCAT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with the GridCAT.  If not, see <http://www.gnu.org/licenses/>.
%
%
% INPUTDLG_GUI MATLAB code for inputdlg_GUI.fig
%      INPUTDLG_GUI, by itself, creates a new INPUTDLG_GUI or raises the existing
%      singleton*.
%
%      H = INPUTDLG_GUI returns the handle to a new INPUTDLG_GUI or the handle to
%      the existing singleton*.
%
%      INPUTDLG_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in INPUTDLG_GUI.M with the given input arguments.
%
%      INPUTDLG_GUI('Property','Value',...) creates a new INPUTDLG_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before inputdlg_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to inputdlg_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help inputdlg_GUI

% Last Modified by GUIDE v2.5 03-Feb-2017 14:42:36

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @inputdlg_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @inputdlg_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before inputdlg_GUI is made visible.
function inputdlg_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to inputdlg_GUI (see VARARGIN)

% Choose default command line output for inputdlg_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% ------------------------------------------------
% mst-edit:

% adapt position of the new GUI
adaptFigurePosition(hObject, 'GridCAT - SelectionDlg');

% Change font size of all GUI elements depending on current platform, if necessary 
ud = getUserData(hObject, 'UserData');
if ~isfield(ud, 'fontSizeAdapted') || ~ud.fontSizeAdapted
    changeFontSizesIfReq(handles, hObject);
end

% Make the GUI modal
set(handles.figure1,'WindowStyle', 'modal');

% change figure name
set(handles.figure1, 'Name', 'GridCAT - Input Dialog');

% Display title
set(handles.text_title, 'String', cell2mat(varargin{1}));

% Set focus on editbox
set(gcf,'Visible','on');
drawnow
uicontrol(handles.edit_inputStr);

% ------------------------------------------------

% UIWAIT makes defineContrastVector_GUI_alt wait for user response (see UIRESUME)
uiwait(handles.figure1); % mst-edit


% --- Outputs from this function are returned to the command line.
function varargout = inputdlg_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% ------------------------------------------------
% mst-edit:
varargout{1} = [];
ud_fig1 = getUserData(handles.figure1, 'UserData');
if isfield(ud_fig1, 'inputOK') && ud_fig1.inputOK
    varargout{1} = get(handles.edit_inputStr, 'String');
end

delete(handles.figure1);
% ------------------------------------------------


% --- Executes on button press in pushbutton_OK.
function pushbutton_OK_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_OK (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% save selected lines on listbox user data

ud_fig1 = getUserData(handles.figure1, 'UserData');

if isValidDirName(get(handles.edit_inputStr, 'String'))
    ud_fig1.inputOK = true;
    set(handles.figure1, 'UserData', ud_fig1);
    close(handles.figure1);
else
    msgbox('This is not a valid directory name.');
end


% --- Executes on button press in pushbutton_Cancel.
function pushbutton_Cancel_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close(handles.figure1);


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
% delete(hObject); % mst-edit

% mst-edit:
if isequal(get(hObject, 'waitstatus'), 'waiting')
    uiresume(hObject);
else
    delete(hObject);
end


function edit_inputStr_Callback(hObject, eventdata, handles)
% hObject    handle to edit_inputStr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_inputStr as text
%        str2double(get(hObject,'String')) returns contents of edit_inputStr as a double

uicontrol(handles.pushbutton_OK);


% --- Executes during object creation, after setting all properties.
function edit_inputStr_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_inputStr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on pushbutton_OK and none of its controls.
function pushbutton_OK_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton_OK (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)

if strcmp(eventdata.Key, 'return')
    pushbutton_OK_Callback(hObject, eventdata, handles)
end
