function varargout = listdlg_GUI(varargin)
%
%     Copyright 2017 Matthias Stangl, Jonathan Shine, Thomas Wolbers
%     matthias.stangl@dzne.de, jonathan.shine@dzne.de, thomas.wolbers@dzne.de
% 
%     This file is part of the GridCAT.
% 
%     The GridCAT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     The GridCAT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with the GridCAT.  If not, see <http://www.gnu.org/licenses/>.
%
%
% LISTDLG_GUI MATLAB code for listdlg_GUI.fig
%      LISTDLG_GUI, by itself, creates a new LISTDLG_GUI or raises the existing
%      singleton*.
%
%      H = LISTDLG_GUI returns the handle to a new LISTDLG_GUI or the handle to
%      the existing singleton*.
%
%      LISTDLG_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LISTDLG_GUI.M with the given input arguments.
%
%      LISTDLG_GUI('Property','Value',...) creates a new LISTDLG_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before listdlg_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to listdlg_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help listdlg_GUI

% Last Modified by GUIDE v2.5 03-Feb-2017 14:43:21

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @listdlg_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @listdlg_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before listdlg_GUI is made visible.
function listdlg_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to listdlg_GUI (see VARARGIN)

% Choose default command line output for listdlg_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% ------------------------------------------------
% mst-edit:

% adapt position of the new GUI
adaptFigurePosition(hObject);

% Change font size of all GUI elements depending on current platform, if necessary 
ud = getUserData(hObject, 'UserData');
if ~isfield(ud, 'fontSizeAdapted') || ~ud.fontSizeAdapted
    changeFontSizesIfReq(handles, hObject);
end

% Make the GUI modal
set(handles.figure1,'WindowStyle', 'modal');

% change figure name
set(handles.figure1, 'Name', ['GridCAT - ' varargin{2}]);

% Set dialog title
set(handles.text_title, 'String', varargin{2});

% Before the GUI is made visible, the listbox should show a list of all elements
list = varargin{1};
if size(list,1) < size(list,2)
    list = list';
end
set(handles.listbox, 'String', list);

% should it be allowed to select multiple listbox elements in parallel?
if length(varargin)>2 && strcmp(varargin{3}, 'multiselect')
    set(handles.listbox, 'Max', 2);
end

drawnow

% ------------------------------------------------

% UIWAIT makes defineContrastVector_GUI_alt wait for user response (see UIRESUME)
uiwait(handles.figure1); % mst-edit


% --- Outputs from this function are returned to the command line.
function varargout = listdlg_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% ------------------------------------------------
% mst-edit:
varargout{1} = [];
ud_listbox = getUserData(handles.listbox, 'UserData');
if isfield(ud_listbox, 'selectedLines')
    varargout{1} = ud_listbox.selectedLines;
end

delete(handles.figure1);
% ------------------------------------------------


% --- Executes on button press in pushbutton_OK.
function pushbutton_OK_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_OK (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% save selected lines on listbox user data

ud_listbox = getUserData(handles.listbox, 'UserData');
ud_listbox.selectedLines = get(handles.listbox, 'Value');
set(handles.listbox, 'UserData', ud_listbox);

close(handles.figure1);


% --- Executes on button press in pushbutton_Cancel.
function pushbutton_Cancel_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close(handles.figure1);


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
% delete(hObject); % mst-edit

% mst-edit:
if isequal(get(hObject, 'waitstatus'), 'waiting')
    uiresume(hObject);
else
    delete(hObject);
end


% --- Executes on selection change in listbox.
function listbox_Callback(hObject, eventdata, handles)
% hObject    handle to listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox


% --- Executes during object creation, after setting all properties.
function listbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_selectAll.
function pushbutton_selectAll_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_selectAll (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.listbox, 'Value', 1:size(get(handles.listbox, 'String'),1))

drawnow
