function varargout = oriCoherence_betweenVox_GUI(varargin)
%
%     Copyright 2017 Matthias Stangl, Jonathan Shine, Thomas Wolbers
%     matthias.stangl@dzne.de, jonathan.shine@dzne.de, thomas.wolbers@dzne.de
% 
%     This file is part of the GridCAT.
% 
%     The GridCAT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     The GridCAT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with the GridCAT.  If not, see <http://www.gnu.org/licenses/>.
%
%
% oriCoherence_betweenVox_GUI MATLAB code for oriCoherence_betweenVox_GUI.fig
%      oriCoherence_betweenVox_GUI, by itself, creates a new oriCoherence_betweenVox_GUI or raises the existing
%      singleton*.
%
%      H = oriCoherence_betweenVox_GUI returns the handle to a new oriCoherence_betweenVox_GUI or the handle to
%      the existing singleton*.
%
%      oriCoherence_betweenVox_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in oriCoherence_betweenVox_GUI.M with the given input arguments.
%
%      oriCoherence_betweenVox_GUI('Property','Value',...) creates a new oriCoherence_betweenVox_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before oriCoherence_betweenVox_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to oriCoherence_betweenVox_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help oriCoherence_betweenVox_GUI

% Last Modified by GUIDE v2.5 23-Jan-2017 18:13:59

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @oriCoherence_betweenVox_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @oriCoherence_betweenVox_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before oriCoherence_betweenVox_GUI is made visible.
function oriCoherence_betweenVox_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to oriCoherence_betweenVox_GUI (see VARARGIN)

% Choose default command line output for oriCoherence_betweenVox_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% ------------------------------------------------
% mst-edit:

% adapt position of the new GUI
% adaptFigurePosition(hObject);

% Change font size of all GUI elements depending on current platform, if necessary 
ud = getUserData(hObject, 'UserData');
if ~isfield(ud, 'fontSizeAdapted') || ~ud.fontSizeAdapted
    changeFontSizesIfReq(handles, hObject);
end

% Make the GUI modal
% set(handles.figure1,'WindowStyle', 'modal');

% Change figure name
set(handles.figure1, 'Name', 'GridCAT - Output');

% read input parameters
ud.dispOutput_flag = varargin{1};
ud.mask_images = varargin{2};
ud.voxelwiseOri_images = varargin{3};
ud.xFoldSymmetry = varargin{4};
set(handles.figure1, 'UserData', ud);

[~, mask_fname, mask_fext] = fileparts(ud.mask_images{1});
[~, voxelwiseOriImg_fname, voxelwiseOriImg_fext] = fileparts(ud.voxelwiseOri_images{1});

set(handles.text_roiMask, 'String', [mask_fname mask_fext]);
set(handles.text_voxelwiseOriImage, 'String', [voxelwiseOriImg_fname voxelwiseOriImg_fext]);

set(handles.text_xFoldSymmetry, 'String', [num2str(ud.xFoldSymmetry) '-fold symmetry ']);

% plot graph in axes
plotData = gridMetric_oriCoherence_betweenVox(ud.dispOutput_flag, ud.mask_images, ud.voxelwiseOri_images, ud.xFoldSymmetry, [0 0], handles.axes1);

% display number of voxels within mask
set(handles.text_nVoxelsWithinMask, 'String', num2str(plotData.mask(1).voxelwiseOriImage(1).nVoxelsWithinMask));
set(handles.text_nNanVoxelsWithinMask, 'String', num2str(plotData.mask(1).voxelwiseOriImage(1).nNanVoxelsWithinMask));

drawnow

% ------------------------------------------------

% UIWAIT makes oriCoherence_betweenVox_GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1); % mst-edit


% --- Executes on button press in checkbox_meanOri_withoutWeighting.
function checkbox_meanOri_withoutWeighting_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_meanOri_withoutWeighting (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_meanOri_withoutWeighting


% --- Executes on button press in checkbox_meanOri_withWeighting.
function checkbox_meanOri_withWeighting_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_meanOri_withWeighting (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_meanOri_withWeighting


% --- Executes on button press in checkbox_Rayleigh.
function checkbox_Rayleigh_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_Rayleigh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_Rayleigh


% --- Executes on selection change in popupmenu_exportData.
function popupmenu_exportData_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_exportData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_exportData contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_exportData

selectedLine = get(handles.popupmenu_exportData, 'Value');

switch selectedLine
    
    case 2
        % --------------------------------------------------------
        % Export voxel-wise orientations as mat-file
        % --------------------------------------------------------
        
        saveToPath = selectionDlg_GUI({'putFile'}, 'Save voxel-wise orientation data to...', pwd, {'*'}, 0, [1 1], 'on', 0, 'GridCAT - main figure', {'.mat'}, 'on', 'voxelwiseGridOri_ROI.mat');
        if ~isempty(saveToPath)
            
            % Get voxelwise orientation values within mask
            ud = getUserData(handles.figure1, 'UserData');
            [~, voxelwiseOri_vol_deg] = loadImage_SPM(ud.voxelwiseOri_images{1});
            [~, mask_vol] = loadImage_SPM(ud.mask_images{1});
            voxelwiseGridOriWithinROI_deg = voxelwiseOri_vol_deg(mask_vol==1);
            
            % save to file
            save([saveToPath{1}],'voxelwiseGridOriWithinROI_deg');    
            disp(['Voxel-wise orientation data saved to: ' saveToPath{1}]);
        end
        
        
    case 3
        
        % --------------------------------------------------------
        % Export voxel-wise orientations as txt-file
        % --------------------------------------------------------

        saveToPath = selectionDlg_GUI({'putFile'}, 'Save voxel-wise orientation data to...', pwd, {'*'}, 0, [1 1], 'on', 0, 'GridCAT - main figure', {'.txt'}, 'on', 'voxelwiseGridOri_ROI.txt');
        if ~isempty(saveToPath)
            
            % Get voxelwise orientation values within mask
            ud = getUserData(handles.figure1, 'UserData');
            [~, voxelwiseOri_vol_deg] = loadImage_SPM(ud.voxelwiseOri_images{1});
            [~, mask_vol] = loadImage_SPM(ud.mask_images{1});
            voxelwiseGridOriWithinROI_deg = voxelwiseOri_vol_deg(mask_vol==1);
            
            % for output as text, round values to lower precision
            voxelwiseGridOriWithinROI_deg = (round(voxelwiseGridOriWithinROI_deg*1000))/1000;
            
            % generate string to save in textfile
            outputStr = mat2str(voxelwiseGridOriWithinROI_deg);
            
            % save to file
            fid = fopen(saveToPath{1},'w+');
            fprintf(fid, outputStr(2:end-1));
            fclose(fid);
            disp(['Voxel-wise orientation data saved to: ' saveToPath{1}]);
        end
        
end
drawnow
        


% --- Executes during object creation, after setting all properties.
function popupmenu_exportData_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_exportData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_redraw.
function pushbutton_redraw_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_redraw (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cla(handles.axes1);

ud = getUserData(handles.figure1, 'UserData');

% calculate mean grid orientation without amplitude-based weighting
plotMeanOri_unweightedWeighted = [0 0];
if get(handles.checkbox_meanOri_withoutWeighting, 'Value')
    plotMeanOri_unweightedWeighted(1) = 1;
end

% calculate mean grid orientation with amplitude-based weighting
if get(handles.checkbox_meanOri_withWeighting, 'Value')
    plotMeanOri_unweightedWeighted(2) = 1;
end

% plot graph in axes
plotData = gridMetric_oriCoherence_betweenVox(ud.dispOutput_flag, ud.mask_images, ud.voxelwiseOri_images, ud.xFoldSymmetry, plotMeanOri_unweightedWeighted, handles.axes1);

% display unweighted mean grid ori in textbox
if isfield(plotData.mask(1).voxelwiseOriImage(1), 'meanGridOri_unweighted')
    set(handles.text_meanOri_withoutWeighting, 'String', [sprintf('%.1f',plotData.mask(1).voxelwiseOriImage(1).meanGridOri_unweighted*180/pi) ' deg.'])
else
    set(handles.text_meanOri_withoutWeighting, 'String', ' ')
end

% display weighted mean grid ori in textbox
if isfield(plotData.mask(1).voxelwiseOriImage(1), 'meanGridOri_weighted')
    set(handles.text_meanOri_withWeighting, 'String', [sprintf('%.1f',plotData.mask(1).voxelwiseOriImage(1).meanGridOri_weighted*180/pi) ' deg.'])
else
    set(handles.text_meanOri_withWeighting, 'String', ' ')
end

% plot result of Rayleigh test for non-uniformity of circular data
if get(handles.checkbox_Rayleigh, 'Value')
    set(handles.text_rayleigh_z, 'String', ['z = ' sprintf('%.3f',plotData.mask(1).voxelwiseOriImage(1).rayleigh_z)])
    set(handles.text_rayleigh_p, 'String', ['p = ' sprintf('%.3f',plotData.mask(1).voxelwiseOriImage(1).rayleigh_p)])
else
    set(handles.text_rayleigh_z, 'String', ' ')
    set(handles.text_rayleigh_p, 'String', ' ')
end

drawnow



% --- Executes on button press in pushbutton_close.
function pushbutton_close_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = oriCoherence_betweenVox_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% ------------------------------------------------
% mst-edit:

% varargout{1} = 'demo output';
% 
% delete(handles.figure1);
% ------------------------------------------------


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject); % mst-edit

% mst-info: This callback needs to be manually included.
% To do this, right-click on the main figure in GUIDE and select "View callbacks -> CloseRequestFcn"

% mst-edit:
% if isequal(get(hObject, 'waitstatus'), 'waiting')
%     uiresume(hObject);
% else
%     delete(hObject);
% end
