function varargout = oriCoherence_withinVox_GUI(varargin)
%
%     Copyright 2017 Matthias Stangl, Jonathan Shine, Thomas Wolbers
%     matthias.stangl@dzne.de, jonathan.shine@dzne.de, thomas.wolbers@dzne.de
% 
%     This file is part of the GridCAT.
% 
%     The GridCAT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     The GridCAT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with the GridCAT.  If not, see <http://www.gnu.org/licenses/>.
%
%
% oriCoherence_withinVox_GUI MATLAB code for oriCoherence_withinVox_GUI.fig
%      oriCoherence_withinVox_GUI, by itself, creates a new oriCoherence_withinVox_GUI or raises the existing
%      singleton*.
%
%      H = oriCoherence_withinVox_GUI returns the handle to a new oriCoherence_withinVox_GUI or the handle to
%      the existing singleton*.
%
%      oriCoherence_withinVox_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in oriCoherence_withinVox_GUI.M with the given input arguments.
%
%      oriCoherence_withinVox_GUI('Property','Value',...) creates a new oriCoherence_withinVox_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before oriCoherence_withinVox_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to oriCoherence_withinVox_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help oriCoherence_withinVox_GUI

% Last Modified by GUIDE v2.5 23-Jan-2017 14:10:40

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @oriCoherence_withinVox_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @oriCoherence_withinVox_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before oriCoherence_withinVox_GUI is made visible.
function oriCoherence_withinVox_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to oriCoherence_withinVox_GUI (see VARARGIN)

% Choose default command line output for oriCoherence_withinVox_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% ------------------------------------------------
% mst-edit:

% adapt position of the new GUI
% adaptFigurePosition(hObject);

% Change font size of all GUI elements depending on current platform, if necessary 
ud = getUserData(hObject, 'UserData');
if ~isfield(ud, 'fontSizeAdapted') || ~ud.fontSizeAdapted
    changeFontSizesIfReq(handles, hObject);
end

% Make the GUI modal
% set(handles.figure1,'WindowStyle', 'modal');

% Change figure name
set(handles.figure1, 'Name', 'GridCAT - Output');

% read input parameters
ud.dispOutput_flag = varargin{1};
ud.mask_images = varargin{2};
ud.voxelwiseOri_images = varargin{3};
ud.xFoldSymmetry = varargin{4};
set(handles.figure1, 'UserData', ud);

[~, mask_fname, mask_fext] = fileparts(ud.mask_images{1});
[~, imgA_fname, imgA_fext] = fileparts(ud.voxelwiseOri_images{1}); % inner image in plot
[~, imgB_fname, imgB_fext] = fileparts(ud.voxelwiseOri_images{2}); % outer image in plot

set(handles.text_roiMask, 'String', [mask_fname mask_fext]);
set(handles.text_innerCircleFile, 'String', [imgA_fname imgA_fext]);
set(handles.text_outerCircleFile, 'String', [imgB_fname imgB_fext]);

set(handles.text_xFoldSymmetry, 'String', [num2str(ud.xFoldSymmetry) '-fold symmetry ']);
set(handles.edit_stableVoxelTh, 'String', num2str(360/ud.xFoldSymmetry/4));

set(handles.text_plotE, 'String', num2str(0));
set(handles.text_plotN, 'String', num2str(round((90/ud.xFoldSymmetry)*10)/10));
set(handles.text_plotW, 'String', num2str(round((180/ud.xFoldSymmetry)*10)/10));
set(handles.text_plotS, 'String', num2str(round((270/ud.xFoldSymmetry)*10)/10));

% default settings:
lineWidth_stableVox = 3;
lineWidth_unstabVox = 3;
lineColor_stableVox = [0.2 0.5 0.3];
lineColor_unstabVox = [1 0 0];
lineStyle_stableVox = '-';
lineStyle_unstabVox = ':';

% plot graph in axes
gridMetric_oriCoherence_withinVox(ud.dispOutput_flag, ud.mask_images, ud.voxelwiseOri_images, ud.xFoldSymmetry, 360/ud.xFoldSymmetry/4, handles.axes1, handles.text_proportionOfStableVoxels, lineWidth_stableVox, lineWidth_unstabVox, lineColor_stableVox, lineColor_unstabVox, lineStyle_stableVox, lineStyle_unstabVox);

drawnow

% ------------------------------------------------

% UIWAIT makes defineContrastVector_GUI_alt wait for user response (see UIRESUME)
% uiwait(handles.figure1); % mst-edit


% --- Outputs from this function are returned to the command line.
function varargout = oriCoherence_withinVox_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% ------------------------------------------------
% mst-edit:

% varargout{1} = 'demo output';
% 
% delete(handles.figure1);
% ------------------------------------------------


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject); % mst-edit

% mst-info: This callback needs to be manually included.
% To do this, right-click on the main figure in GUIDE and select "View callbacks -> CloseRequestFcn"

% mst-edit:
% if isequal(get(hObject, 'waitstatus'), 'waiting')
%     uiresume(hObject);
% else
%     delete(hObject);
% end


% --- Executes on button press in pushbutton_close.
function pushbutton_close_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close(handles.figure1);



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double


% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_stableVoxelTh_Callback(hObject, eventdata, handles)
% hObject    handle to edit_stableVoxelTh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_stableVoxelTh as text
%        str2double(get(hObject,'String')) returns contents of edit_stableVoxelTh as a double


% --- Executes during object creation, after setting all properties.
function edit_stableVoxelTh_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_stableVoxelTh (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_lineColor_unstableVoxels_Callback(hObject, eventdata, handles)
% hObject    handle to edit_lineColor_unstableVoxels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_lineColor_unstableVoxels as text
%        str2double(get(hObject,'String')) returns contents of edit_lineColor_unstableVoxels as a double


% --- Executes during object creation, after setting all properties.
function edit_lineColor_unstableVoxels_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_lineColor_unstableVoxels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_lineStyle_stableVoxels.
function popupmenu_lineStyle_stableVoxels_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_lineStyle_stableVoxels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_lineStyle_stableVoxels contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_lineStyle_stableVoxels


% --- Executes during object creation, after setting all properties.
function popupmenu_lineStyle_stableVoxels_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_lineStyle_stableVoxels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_lineColor_stableVoxels_Callback(hObject, eventdata, handles)
% hObject    handle to edit_lineColor_stableVoxels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_lineColor_stableVoxels as text
%        str2double(get(hObject,'String')) returns contents of edit_lineColor_stableVoxels as a double


% --- Executes during object creation, after setting all properties.
function edit_lineColor_stableVoxels_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_lineColor_stableVoxels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_lineStyle_unstableVoxels.
function popupmenu_lineStyle_unstableVoxels_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_lineStyle_unstableVoxels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_lineStyle_unstableVoxels contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_lineStyle_unstableVoxels


% --- Executes during object creation, after setting all properties.
function popupmenu_lineStyle_unstableVoxels_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_lineStyle_unstableVoxels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function edit_lineWidth_stableVoxels_Callback(hObject, eventdata, handles)
% hObject    handle to edit_lineWidth_stableVoxels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_lineWidth_stableVoxels as text
%        str2double(get(hObject,'String')) returns contents of edit_lineWidth_stableVoxels as a double


% --- Executes during object creation, after setting all properties.
function edit_lineWidth_unstableVoxels_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_lineWidth_unstableVoxels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function edit_lineWidth_stableVoxels_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_lineWidth_stableVoxels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in pushbutton_redraw.
function pushbutton_redraw_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_redraw (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cla(handles.axes1);

ud = getUserData(handles.figure1, 'UserData');

lineWidth_stableVox = str2double(get(handles.edit_lineWidth_stableVoxels, 'String'));
lineWidth_unstabVox = str2double(get(handles.edit_lineWidth_unstableVoxels, 'String'));
lineColor_stableVox = str2num(get(handles.edit_lineColor_stableVoxels, 'String'));
lineColor_unstabVox = str2num(get(handles.edit_lineColor_unstableVoxels, 'String'));
switch get(handles.popupmenu_lineStyle_stableVoxels, 'Value')
    case 1, lineStyle_stableVox='-';
    case 2, lineStyle_stableVox='--';
    case 3, lineStyle_stableVox=':';
    case 4, lineStyle_stableVox='none';
end
switch get(handles.popupmenu_lineStyle_unstableVoxels, 'Value')
    case 1, lineStyle_unstabVox='-';
    case 2, lineStyle_unstabVox='--';
    case 3, lineStyle_unstabVox=':';
    case 4, lineStyle_unstabVox='none';
end
gridMetric_oriCoherence_withinVox(1, ud.mask_images, ud.voxelwiseOri_images, ud.xFoldSymmetry, str2double(get(handles.edit_stableVoxelTh, 'String')), handles.axes1, handles.text_proportionOfStableVoxels, lineWidth_stableVox, lineWidth_unstabVox, lineColor_stableVox, lineColor_unstabVox, lineStyle_stableVox, lineStyle_unstabVox);



function edit_lineWidth_unstableVoxels_Callback(hObject, eventdata, handles)
% hObject    handle to edit_lineWidth_unstableVoxels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_lineWidth_unstableVoxels as text
%        str2double(get(hObject,'String')) returns contents of edit_lineWidth_unstableVoxels as a double
