function varargout = questdlg_GUI(varargin)
%
%     Copyright 2017 Matthias Stangl, Jonathan Shine, Thomas Wolbers
%     matthias.stangl@dzne.de, jonathan.shine@dzne.de, thomas.wolbers@dzne.de
% 
%     This file is part of the GridCAT.
% 
%     The GridCAT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     The GridCAT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with the GridCAT.  If not, see <http://www.gnu.org/licenses/>.
%
%
% QUESTDLG_GUI MATLAB code for questdlg_GUI.fig
%      QUESTDLG_GUI, by itself, creates a new QUESTDLG_GUI or raises the existing
%      singleton*.
%
%      H = QUESTDLG_GUI returns the handle to a new QUESTDLG_GUI or the handle to
%      the existing singleton*.
%
%      QUESTDLG_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in QUESTDLG_GUI.M with the given input arguments.
%
%      QUESTDLG_GUI('Property','Value',...) creates a new QUESTDLG_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before questdlg_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to questdlg_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help questdlg_GUI

% Last Modified by GUIDE v2.5 10-Dec-2016 13:16:00

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @questdlg_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @questdlg_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before questdlg_GUI is made visible.
function questdlg_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to questdlg_GUI (see VARARGIN)

% Choose default command line output for questdlg_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% ------------------------------------------------
% mst-edit:

% adapt position of the new GUI
adaptFigurePosition(hObject);

% Change font size of all GUI elements depending on current platform, if necessary 
ud = getUserData(hObject, 'UserData');
if ~isfield(ud, 'fontSizeAdapted') || ~ud.fontSizeAdapted
    changeFontSizesIfReq(handles, hObject);
end

% Make the GUI modal
set(handles.figure1,'WindowStyle', 'modal');

% change figure name
set(handles.figure1, 'Name', 'Please confirm...');

% Display title
set(handles.text_title, 'String', cell2mat(varargin{1}));

% Set names for pushbuttons
set(handles.pushbutton_1, 'String', varargin{2});
set(handles.pushbutton_2, 'String', varargin{3});

% Set focus on button "yes"
set(gcf,'Visible','on');
drawnow
uicontrol(handles.pushbutton_2);

% ------------------------------------------------

% UIWAIT makes defineContrastVector_GUI_alt wait for user response (see UIRESUME)
uiwait(handles.figure1); % mst-edit


% --- Outputs from this function are returned to the command line.
function varargout = questdlg_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% ------------------------------------------------
% mst-edit:

varargout{1} = [];

ud = getUserData(handles.figure1, 'UserData');
if isfield(ud, 'output')
    varargout{1} = ud.output;
end

delete(handles.figure1);
% ------------------------------------------------


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
% delete(hObject); % mst-edit

% mst-info: This callback needs to be manually included.
% To do this, right-click on the main figure in GUIDE and select "View callbacks -> CloseRequestFcn"

% mst-edit:
if isequal(get(hObject, 'waitstatus'), 'waiting')
    uiresume(hObject);
else
    delete(hObject);
end


% --- Executes on button press in pushbutton_2.
function pushbutton_2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ud = getUserData(handles.figure1, 'UserData');
ud.output = get(handles.pushbutton_2, 'String');
set(handles.figure1, 'UserData', ud);

close(handles.figure1);


% --- Executes on button press in pushbutton_1.
function pushbutton_1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ud = getUserData(handles.figure1, 'UserData');
ud.output = get(handles.pushbutton_1, 'String');
set(handles.figure1, 'UserData', ud);

close(handles.figure1);


% --- Executes on key press with focus on pushbutton_2 and none of its controls.
function pushbutton_2_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton_2 (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)

if strcmp(eventdata.Key, 'return')
    pushbutton_yes_Callback(hObject, eventdata, handles)
end
