function saveCellArrayToTextfile(saveData, defaultDir, defaultFilename, specifyDestination_flag)
%
%     Copyright 2017 Matthias Stangl, Jonathan Shine, Thomas Wolbers
%     matthias.stangl@dzne.de, jonathan.shine@dzne.de, thomas.wolbers@dzne.de
% 
%     This file is part of the GridCAT.
% 
%     The GridCAT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     The GridCAT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with the GridCAT.  If not, see <http://www.gnu.org/licenses/>.
%
%
% Save cell array of strings to textfile.


% what will be the extension of the file?
[~, ~, fext] = fileparts(defaultFilename);

if exist('specifyDestination_flag', 'var') && specifyDestination_flag
    
    % specify destination of output file
    saveToPath = selectionDlg_GUI({'putFile'}, 'Save to...', defaultDir, {'*'}, 0, [1 1], 'on', 0, 'GridCAT - main figure', {fext}, 'on', defaultFilename);

else
   
    % do not ask for destination, just save it to the default destination
    saveToPath = {[defaultDir filesep defaultFilename]};
    
end

% save data to file
if ~isempty(saveToPath)
    fid = fopen(saveToPath{1}, 'w+');
    for lineNr = 1:size(saveData,1)
        fprintf(fid,'%s\r\n',saveData{lineNr,:});
    end
    disp(['Output saved to: ' saveToPath{1}]);
    fclose(fid);
end


