function hfig = setInteractiveWindow_SPM(defaultText)
%
%     Copyright 2017 Matthias Stangl, Jonathan Shine, Thomas Wolbers
%     matthias.stangl@dzne.de, jonathan.shine@dzne.de, thomas.wolbers@dzne.de
% 
%     This file is part of the GridCAT.
% 
%     The GridCAT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     The GridCAT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with the GridCAT.  If not, see <http://www.gnu.org/licenses/>.
%
%
% SPM's interactive window is initialized and displayed.

hfig = spm_figure('FindWin','Interactive');
if isempty(hfig)
    % create SPM's interactive window (which shows usually a progress bar etc.)
    hfig = spm('CreateIntWin'); % alternatively: hfig = figure('Tag', 'Interactive', 'MenuBar', 'none', 'Visible', 'off');
end
figure(hfig);
text(0.5, 0.5, defaultText, 'HorizontalAlignment', 'Center');
axis off
set(hfig, 'Visible', 'on');
drawnow