function specifyGLM(cfg)
%
%     Copyright 2017 Matthias Stangl, Jonathan Shine, Thomas Wolbers
%     matthias.stangl@dzne.de, jonathan.shine@dzne.de, thomas.wolbers@dzne.de
% 
%     This file is part of the GridCAT.
% 
%     The GridCAT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     The GridCAT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with the GridCAT.  If not, see <http://www.gnu.org/licenses/>.
%
%
% Specify GLM1 or GLM2 for grid code analysis


%% READ EVENT-TABLE

for runIdx = 1:length(cfg.rawData.run)
    cfg.eventInfo.run(runIdx) = readEventTable(cfg.rawData.run(runIdx).eventTable_file);
end


%% WHICH GRID EVENTS SHOULD BE MODELED?

cfg = specifyEventUsageForGLM(cfg);


%% GENERATE SPM MULTIPLE CONDITIONS FILE

cfg = generateMultiCondFile(cfg);


%% CREATE GridCAT_GLMx.mat FILE AND SAVE cfg ON IT

save([cfg.GLM.dataDir filesep 'GridCAT_GLM' num2str(cfg.GLMnr) '.mat'], 'cfg');


%% SPECIFY SPM MODEL

spmModel_spec(cfg);


